//
//  DLL linker script for S2 using low memory
//  (just above the main application)
//
//  Adjust dllStartAddr below as necessary to avoid conflicts 
//  between DLL and APP
//
CONSTANTS {
	 dllStartAddr  = 0x01C00000

    heap_reserve  = 0
    stack_reserve = 8192
}
//
// Program layout for PIC and PID built programs.
//
SECTIONS
{
//
// The text segment
//
//
// BA: set the start address to 
//
//         SDRAM start + APP size  + max. DLL size + 128
//
//     to get independent of product-specific RAM size. 
//
//     As long as this is significantly below 48 MByte, where the APP is
//     loaded this should be quite safe for all products.
//
    .picbase                   dllStartAddr :
    .text                                   :
    .syscall                                :
    .intercall                              :
    .interfunc                              :
    .fixaddr                                :
    .fixtype                                :
	 .rodata		                             :
	 .rodata.str1.4                          :
    .secinfo                                :
    .linfix                                 :
//
// The data segment
//

    .pidbase                                 :
    .sdabase                                 :
    .sbss                                    :
    .sdata                                   :
    .data                                    :
    .bss                                     :
    .heap       ALIGN(16) PAD(heap_reserve)  :
    .stack      ALIGN(16) PAD(stack_reserve) :
    .gstackfix  ALIGN(16) PAD(stack_reserve) :
//
// MULTI6 unused virtual functions (for DLLs)
//
	.ghs.uvfd.vtbl	NOLOAD                    : 
	.ghs.uvfd.rout NOLOAD                    :
//
// relocation infos for the unused sections above
//
//	.rela.ghs.uvfd.vtbl NOLOAD					:
//	.rela.ghs.uvfd.rout NOLOAD					:
//
// Note, that ".rela.*" sections SHOULD NEVER be relocated by
// this linker script. These sections contain the relocation
// information for other sections, but no code or data used
// during execution. Explicitly relocating them is likely to
// ask for problems when the DLL is loaded, e.g. because their
// contents is no longer recognized by the loader. It may even
// trigger bugs in the linker itself.
}
