#ifndef ORIG_AUTH_INFO_H_INCLUDED
#define ORIG_AUTH_INFO_H_INCLUDED

// structs for e.g. supply Syslog original authentication for current action from an local RCP client

struct RCP_OriginalAuthInfo        // RCP optional header => be careful when change layout => also keep DWORD-Alignment
{                                  
   char LoginUserName[32];         // ID (in local user mgmt) of user who initialized the current action
   char LoginServerName[16];       // ID of server which initially verified the authentication. (Where the request entered the local device)
                                   // => e.g. HTTP, RTSP, RCP (NOT those of a local link server)
   char ClientAdress[40];          // Client IPv4/IPv6 Addr, maybe host name?
};


struct t_OrigAuthInfo              // for local ram, e.g. calling syslog
{
                                   // ATTENTION size of this must not exceed DLL_ORIG_AUTH_INFO_BUFF_SIZE (256) which is intentionally decoupled from this struct  	
                                   
   // AuthLevel  => extend here some extra local info
   
#define OAI_USER_UNKNOWN              0  // means not (yet) verified
#define OAI_USER_LOCAL_DAEMON       -42  // a local system daemon which run on its own. (e.g. recording sceduler) with service rights (NOT allowd for proxies like HTTP, RTSP etc.)
#define OAI_USER_DERIVE_FROM_THREAD -41  // indicates that the info should be derived from the calling thread instead from this info
#define OAI_USER_MAX           16        // Aritrary level for sanity check only
  int LocalUserId;                       // In future intended to be the id from the local user manager if there is some

  struct RCP_OriginalAuthInfo Ai; 
};


#ifdef __cplusplus
  extern "C" {
#endif   

struct t_OrigAuthInfo *OrigAuthInfoSetup(struct t_OrigAuthInfo *pOai, const char *pUser, const char *pServer, int LocalUserId);

#ifdef __cplusplus
  }
#endif   


#endif // ORIG_AUTH_INFO_H_INCLUDED

