#include "ZBarcode.h"
#include <stdlib.h>
//#include "vcsPrint.h"



C_ZBar::C_ZBar(void* handle):
	m_Callback(NULL),
	m_handle(handle)
{

}


C_ZBar::~C_ZBar()
{
	g_ZBarMemory->unregisterMemory(m_handle);
}
	

bool C_ZBar::Create(UInt32 maxPicBufferSize)
{
	if (!g_ZBarMemory->registerMemory(m_handle, maxPicBufferSize + CALCULATOR_BUFFER_SIZE))
	{
		return false;
	}
	return true;
}


unsigned char* C_ZBar::getPicBuffer(UInt32 picBufferSize)
{
	return g_ZBarMemory->getMemory(picBufferSize);
}


int C_ZBar::scanImage(unsigned char* Source, long Width, long Height)
{
	zbar_image_scanner_t* _scanner = zbar_image_scanner_create();
	zbar_image_scanner_set_config(_scanner,	ZBAR_NONE, ZBAR_CFG_ENABLE, 1);

	zbar_image_t* _image = zbar_image_create();
    unsigned long fourcc = (("Y800"[0] & 0xff) |
                            (("Y800"[1] & 0xff) << 8) |
                            (("Y800"[2] & 0xff) << 16) |
                            (("Y800"[3] & 0xff) << 24));
	zbar_image_set_format(_image, fourcc);
	zbar_image_set_size(_image, Width, Height);
	zbar_image_set_data(_image, Source, Width * Height, NULL);

	//int start = C_Time::GetTime1MS();
	int n = zbar_scan_image(_scanner, _image);
	//int end = C_Time::GetTime1MS();
	//int diff = end - start;

	if(n == 1)
	{
		const zbar_symbol_t *symbol = zbar_image_first_symbol(_image);
		//for(; symbol; symbol = zbar_symbol_next(symbol)) {
		//  zbar_symbol_type_t typ = zbar_symbol_get_type(symbol);
		const char *buf = zbar_symbol_get_data(symbol);
		int len = zbar_symbol_get_data_length(symbol);
		if(m_Callback)
			m_Callback->setQRInfo(n, (unsigned char*)buf, len);
		//}
	}
	else
	{
		if(m_Callback)
			m_Callback->setQRInfo(n, NULL, 0);
	}

	//zbar_image_destroy(_image);				replaced by "theMemory->resetMemory();"
	//zbar_image_scanner_destroy(_scanner);		replaced by "theMemory->resetMemory();"
	g_ZBarMemory->resetMemory();					// clear complete memory

	return n;
}


bool C_ZBar::resetMemory()
{
	g_ZBarMemory->resetMemory();

	return true;
}


